<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>birdshot.cli &#8212; birdshot 0.0.post1.dev20+g168d24e.d20231220 documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=fa44fd50" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=233b9934" />
    <script src="../../_static/documentation_options.js?v=c5a7b33d"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for birdshot.cli</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">BIRDSHOT project actions.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">click</span>
<span class="c1"># import argparse</span>
<span class="kn">import</span> <span class="nn">logging</span>

<span class="kn">from</span> <span class="nn">birdshot</span> <span class="kn">import</span> <span class="n">__version__</span>
<span class="kn">from</span> <span class="nn">birdshot</span> <span class="kn">import</span> <span class="n">Birdshot</span>

<span class="n">__author__</span> <span class="o">=</span> <span class="s2">&quot;Branden Kappes&quot;</span>
<span class="n">__copyright__</span> <span class="o">=</span> <span class="s2">&quot;Branden Kappes&quot;</span>
<span class="n">__license__</span> <span class="o">=</span> <span class="s2">&quot;MIT&quot;</span>


<span class="k">if</span> <span class="s2">&quot;DEBUG&quot;</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">DEBUG</span><span class="p">)</span>
<span class="k">if</span> <span class="s2">&quot;INFO&quot;</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">INFO</span><span class="p">)</span>
<span class="k">if</span> <span class="s2">&quot;WARNING&quot;</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">WARNING</span><span class="p">)</span>
<span class="k">if</span> <span class="s2">&quot;ERROR&quot;</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">ERROR</span><span class="p">)</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">logging</span><span class="o">.</span><span class="n">basicConfig</span><span class="p">(</span><span class="n">level</span><span class="o">=</span><span class="n">logging</span><span class="o">.</span><span class="n">CRITICAL</span><span class="p">)</span>

<span class="c1"># logging.basicConfig(level=logging.DEBUG)</span>


<div class="viewcode-block" id="UserNotFoundError">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.cli.UserNotFoundError">[docs]</a>
<span class="k">class</span> <span class="nc">UserNotFoundError</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">pass</span></div>



<div class="viewcode-block" id="Storage">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.cli.Storage">[docs]</a>
<span class="k">class</span> <span class="nc">Storage</span><span class="p">:</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">username</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">password</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">url</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="o">*</span><span class="p">,</span> <span class="n">skip_validation</span><span class="p">:</span> <span class="nb">bool</span><span class="o">=</span><span class="kc">False</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_heap</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">_stack</span> <span class="o">=</span> <span class="nb">list</span><span class="p">()</span>
        <span class="c1"># Setup the birdshot object</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">username</span> <span class="ow">or</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;CARTA_USER&quot;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
        <span class="n">passwd</span> <span class="o">=</span> <span class="n">password</span> <span class="ow">or</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;CARTA_PASS&quot;</span><span class="p">,</span> <span class="kc">None</span><span class="p">)</span>
        <span class="n">url</span> <span class="o">=</span> <span class="n">url</span> <span class="ow">or</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;CARTA_API_URL&quot;</span><span class="p">,</span> <span class="s2">&quot;https://api.carta.contextualize.us.com&quot;</span><span class="p">)</span>
        <span class="c1"># Create birdshot</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">user</span> <span class="ow">and</span> <span class="n">passwd</span><span class="p">)</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">skip_validation</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">birdshot</span> <span class="o">=</span> <span class="n">Birdshot</span><span class="p">(</span><span class="n">user</span><span class="p">,</span> <span class="n">passwd</span><span class="p">,</span> <span class="n">url</span><span class="o">=</span><span class="n">url</span><span class="p">)</span>
                <span class="n">logging</span><span class="o">.</span><span class="n">debug</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;Authenticated user (xxx</span><span class="si">{</span><span class="n">user</span><span class="p">[</span><span class="o">-</span><span class="mi">3</span><span class="p">:]</span><span class="si">}</span><span class="s2">) with password (xxx</span><span class="si">{</span><span class="n">passwd</span><span class="p">[</span><span class="o">-</span><span class="mi">3</span><span class="p">:]</span><span class="si">}</span><span class="s2">).&quot;</span><span class="p">)</span>
            <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
                <span class="n">msg</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;Failed to authenticate BIRDSHOT user </span><span class="si">{</span><span class="n">user</span><span class="si">!r}</span><span class="s2">. &quot;</span> \
                      <span class="sa">f</span><span class="s2">&quot;Check your network connection, username, password, and &quot;</span> \
                      <span class="sa">f</span><span class="s2">&quot;Carta API URL. These may be set on the CLI or in &quot;</span> \
                      <span class="sa">f</span><span class="s2">&quot;environment variables CARTA_USER, CARTA_PASS, and &quot;</span> \
                      <span class="sa">f</span><span class="s2">&quot;CARTA_API_URL, respectively. Failed with message: </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">e</span><span class="p">)</span><span class="si">}</span><span class="s2">&quot;</span>
                <span class="k">raise</span> <span class="n">UserNotFoundError</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">birdshot</span> <span class="o">=</span> <span class="kc">None</span></div>



<span class="nd">@click</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="n">chain</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--no-auth&quot;</span><span class="p">,</span>
    <span class="n">is_flag</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
    <span class="n">show_default</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;If a command chain does not require authentication, authenticate with Carta may be skipped.&quot;</span>
<span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-u&quot;</span><span class="p">,</span> <span class="s2">&quot;--username&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Carta username. Default: looks for the username in the CARTA_USER environment variable.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;-p&quot;</span><span class="p">,</span> <span class="s2">&quot;--password&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="nb">str</span><span class="p">,</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Carta password. Default: Looks for the password in the CARTA_PASS environment variable.&quot;</span><span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">option</span><span class="p">(</span>
    <span class="s2">&quot;--url&quot;</span><span class="p">,</span>
    <span class="nb">type</span><span class="o">=</span><span class="n">click</span><span class="o">.</span><span class="n">Choice</span><span class="p">([</span>
        <span class="s2">&quot;https://api.carta.contextualize.us.com&quot;</span><span class="p">,</span>
        <span class="s2">&quot;https://api.sandbox.carta.contextualize.us.com&quot;</span>
    <span class="p">]),</span>
    <span class="n">default</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
    <span class="n">help</span><span class="o">=</span><span class="s2">&quot;Development Only. Base URL of the Carta API.&quot;</span>
<span class="p">)</span>
<span class="nd">@click</span><span class="o">.</span><span class="n">pass_context</span>
<span class="k">def</span> <span class="nf">cli</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">no_auth</span><span class="p">,</span> <span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">url</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    BIRDSHOT object manipulation.</span>
<span class="sd">    </span>
<span class="sd">    This CLI allows users to read, write, and manipulate data stored in the</span>
<span class="sd">    BIRDSHOT project Google Drive from the command line.</span>

<span class="sd">    Logging can be enabled by setting DEBUG, INFO, WARNING, or ERROR</span>
<span class="sd">    environment variables.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">ctx</span><span class="o">.</span><span class="n">obj</span> <span class="o">=</span> <span class="n">Storage</span><span class="p">(</span><span class="n">username</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">url</span><span class="p">,</span> <span class="n">skip_validation</span><span class="o">=</span><span class="n">no_auth</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">msg</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;An error occured. The following information may help, </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">e</span><span class="p">)</span><span class="si">!r}</span><span class="s2">&quot;</span>
        <span class="k">raise</span> <span class="n">click</span><span class="o">.</span><span class="n">UsageError</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span>


<div class="viewcode-block" id="process_commands">
<a class="viewcode-back" href="../../api/birdshot.html#birdshot.cli.process_commands">[docs]</a>
<span class="nd">@cli</span><span class="o">.</span><span class="n">result_callback</span><span class="p">()</span>
<span class="k">def</span> <span class="nf">process_commands</span><span class="p">(</span><span class="n">processors</span><span class="p">,</span> <span class="o">**</span><span class="n">kwds</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This result callback is invoked with an iterable of all the chained</span>
<span class="sd">    subcommands.  Each subcommand returns a function that is chained together</span>
<span class="sd">    to feed one into the other, similar to how a pipe on unix works.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="c1"># Start with an empty iterable.</span>
    <span class="n">stream</span> <span class="o">=</span> <span class="p">()</span>

    <span class="c1"># Pipe it through all stream processors.</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">processor</span> <span class="ow">in</span> <span class="n">processors</span><span class="p">:</span>
            <span class="n">stream</span> <span class="o">=</span> <span class="n">processor</span><span class="p">(</span><span class="n">stream</span><span class="p">)</span>
    <span class="k">except</span> <span class="ne">Exception</span> <span class="k">as</span> <span class="n">e</span><span class="p">:</span>
        <span class="n">msg</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;An error occured. The following information may help, </span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">e</span><span class="p">)</span><span class="si">!r}</span><span class="s2">&quot;</span>
        <span class="k">raise</span> <span class="n">click</span><span class="o">.</span><span class="n">UsageError</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span>

    <span class="c1"># Evaluate the stream and throw away the items.</span>
    <span class="k">for</span> <span class="n">_</span> <span class="ow">in</span> <span class="n">stream</span><span class="p">:</span>
        <span class="k">pass</span></div>



<span class="c1"># Add commands</span>
<span class="kn">from</span> <span class="nn">.operations</span> <span class="kn">import</span> <span class="p">(</span>
    <span class="n">load</span><span class="p">,</span> <span class="n">dump</span><span class="p">,</span> <span class="n">dumps</span><span class="p">,</span> <span class="n">tabulate</span><span class="p">,</span> <span class="n">to_csv</span><span class="p">,</span> <span class="n">store</span><span class="p">,</span> <span class="n">field</span><span class="p">,</span> <span class="n">get</span><span class="p">,</span> <span class="n">iter_</span><span class="p">,</span> <span class="n">push</span><span class="p">,</span> <span class="n">pop</span><span class="p">,</span>
    <span class="n">model_dump</span><span class="p">,</span> <span class="n">drop</span><span class="p">,</span> <span class="n">len_</span><span class="p">,</span> <span class="n">dict_</span><span class="p">,</span> <span class="n">list_</span><span class="p">,</span> <span class="n">where</span><span class="p">,</span> <span class="n">any_</span><span class="p">,</span> <span class="n">all_</span><span class="p">,</span> <span class="n">strip</span><span class="p">,</span> <span class="n">apply</span><span class="p">,</span>
    <span class="n">bool_</span><span class="p">,</span> <span class="n">str_</span><span class="p">,</span> <span class="n">replace</span><span class="p">,</span> <span class="n">graph</span><span class="p">,</span> <span class="n">nodes</span><span class="p">,</span> <span class="n">node_filter</span><span class="p">,</span> <span class="n">unpack</span><span class="p">,</span> <span class="n">path</span><span class="p">,</span> <span class="n">download</span><span class="p">,</span>
    <span class="n">parents</span><span class="p">,</span> <span class="n">children</span><span class="p">,</span> <span class="n">aggregate</span><span class="p">,</span> <span class="n">propagate</span><span class="p">,</span> <span class="n">reduce</span>
<span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">load</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">dump</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">dumps</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">tabulate</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;to-csv&quot;</span><span class="p">)(</span><span class="n">to_csv</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">store</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">field</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">get</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;iter&quot;</span><span class="p">)(</span><span class="n">iter_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">push</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">pop</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;model-dump&quot;</span><span class="p">)(</span><span class="n">model_dump</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">drop</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;len&quot;</span><span class="p">)(</span><span class="n">len_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;dict&quot;</span><span class="p">)(</span><span class="n">dict_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">where</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;any&quot;</span><span class="p">)(</span><span class="n">any_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;all&quot;</span><span class="p">)(</span><span class="n">all_</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">apply</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;bool&quot;</span><span class="p">)(</span><span class="n">bool_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;str&quot;</span><span class="p">)(</span><span class="n">str_</span><span class="p">)</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">strip</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">replace</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">graph</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">nodes</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;list&quot;</span><span class="p">)(</span><span class="n">list_</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">(</span><span class="s2">&quot;node-filter&quot;</span><span class="p">)(</span><span class="n">node_filter</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">path</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">download</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">parents</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">children</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">aggregate</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">propagate</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">reduce</span><span class="p">)</span> <span class="c1"># tested</span>
<span class="n">cli</span><span class="o">.</span><span class="n">command</span><span class="p">()(</span><span class="n">unpack</span><span class="p">)</span> <span class="c1"># tested</span>


<span class="c1"># ---- Python API ----</span>
<span class="c1"># The functions defined in this section can be imported by users in their</span>
<span class="c1"># Python scripts/interactive interpreter, e.g. via</span>
<span class="c1"># `from birdshot.skeleton import fib`,</span>
<span class="c1"># when using this Python module as a library.</span>


<span class="c1"># ---- CLI ----</span>
<span class="c1"># The functions defined in this section are wrappers around the main Python</span>
<span class="c1"># API allowing them to be called directly from the terminal as a CLI</span>
<span class="c1"># executable/script.</span>


<span class="c1"># def parse_args(args):</span>
<span class="c1">#     &quot;&quot;&quot;Parse command line parameters</span>

<span class="c1">#     Args:</span>
<span class="c1">#       args (List[str]): command line parameters as list of strings</span>
<span class="c1">#           (for example  ``[&quot;--help&quot;]``).</span>

<span class="c1">#     Returns:</span>
<span class="c1">#       :obj:`argparse.Namespace`: command line parameters namespace</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#     parser = argparse.ArgumentParser(description=&quot;Just a Fibonacci demonstration&quot;)</span>
<span class="c1">#     parser.add_argument(</span>
<span class="c1">#         &quot;--version&quot;,</span>
<span class="c1">#         action=&quot;version&quot;,</span>
<span class="c1">#         version=f&quot;birdshot {__version__}&quot;,</span>
<span class="c1">#     )</span>
<span class="c1">#     parser.add_argument(dest=&quot;n&quot;, help=&quot;n-th Fibonacci number&quot;, type=int, metavar=&quot;INT&quot;)</span>
<span class="c1">#     parser.add_argument(</span>
<span class="c1">#         &quot;-v&quot;,</span>
<span class="c1">#         &quot;--verbose&quot;,</span>
<span class="c1">#         dest=&quot;loglevel&quot;,</span>
<span class="c1">#         help=&quot;set loglevel to INFO&quot;,</span>
<span class="c1">#         action=&quot;store_const&quot;,</span>
<span class="c1">#         const=logging.INFO,</span>
<span class="c1">#     )</span>
<span class="c1">#     parser.add_argument(</span>
<span class="c1">#         &quot;-vv&quot;,</span>
<span class="c1">#         &quot;--very-verbose&quot;,</span>
<span class="c1">#         dest=&quot;loglevel&quot;,</span>
<span class="c1">#         help=&quot;set loglevel to DEBUG&quot;,</span>
<span class="c1">#         action=&quot;store_const&quot;,</span>
<span class="c1">#         const=logging.DEBUG,</span>
<span class="c1">#     )</span>
<span class="c1">#     return parser.parse_args(args)</span>


<span class="c1"># def setup_logging(loglevel):</span>
<span class="c1">#     &quot;&quot;&quot;Setup basic logging</span>

<span class="c1">#     Args:</span>
<span class="c1">#       loglevel (int): minimum loglevel for emitting messages</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#     logformat = &quot;[%(asctime)s] %(levelname)s:%(name)s:%(message)s&quot;</span>
<span class="c1">#     logging.basicConfig(</span>
<span class="c1">#         level=loglevel, stream=sys.stdout, format=logformat, datefmt=&quot;%Y-%m-%d %H:%M:%S&quot;</span>
<span class="c1">#     )</span>


<span class="c1"># def main(args):</span>
<span class="c1">#     &quot;&quot;&quot;Wrapper allowing :func:`fib` to be called with string arguments in a CLI fashion</span>

<span class="c1">#     Instead of returning the value from :func:`fib`, it prints the result to the</span>
<span class="c1">#     ``stdout`` in a nicely formatted message.</span>

<span class="c1">#     Args:</span>
<span class="c1">#       args (List[str]): command line parameters as list of strings</span>
<span class="c1">#           (for example  ``[&quot;--verbose&quot;, &quot;42&quot;]``).</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#     args = parse_args(args)</span>
<span class="c1">#     setup_logging(args.loglevel)</span>
<span class="c1">#     _logger.debug(&quot;Starting crazy calculations...&quot;)</span>
<span class="c1">#     print(f&quot;The {args.n}-th Fibonacci number is {fib(args.n)}&quot;)</span>
<span class="c1">#     _logger.info(&quot;Script ends here&quot;)</span>


<span class="c1"># def run():</span>
<span class="c1">#     &quot;&quot;&quot;Calls :func:`main` passing the CLI arguments extracted from :obj:`sys.argv`</span>

<span class="c1">#     This function can be used as entry point to create console scripts with setuptools.</span>
<span class="c1">#     &quot;&quot;&quot;</span>
<span class="c1">#     main(sys.argv[1:])</span>


<span class="c1"># if __name__ == &quot;__main__&quot;:</span>
<span class="c1">#     # ^  This is a guard statement that will prevent the following code from</span>
<span class="c1">#     #    being executed in the case someone imports this file instead of</span>
<span class="c1">#     #    executing it as a script.</span>
<span class="c1">#     #    https://docs.python.org/3/library/__main__.html</span>

<span class="c1">#     # After installing your project with pip, users can also run your Python</span>
<span class="c1">#     # modules as scripts via the ``-m`` flag, as defined in PEP 338::</span>
<span class="c1">#     #</span>
<span class="c1">#     #     python -m birdshot.skeleton 42</span>
<span class="c1">#     #</span>
<span class="c1">#     run()</span>
</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">birdshot</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../readme.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../cli.html">CLI</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../contributing.html">Contributions &amp; Help</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../license.html">License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../authors.html">Authors</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../changelog.html">Changelog</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../api/modules.html">Module Reference</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Contextualize LLC.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>